<template>
    <div>
        <loading :active.sync="loading" is-full-page></loading>
        <md-dialog id="modal-login" :md-active.sync="classicModal" class="md-round classic-modal">
            <md-toolbar class="md-accent main-navbar" md-elevation="1">
                <div class="md-toolbar-row md-layout md-alignment-top-center">
                    <div class="md-layout md-alignment-top-left">
                        <md-button class="md-icon-button" @click="searchModalHide">
                            <md-icon>arrow_back</md-icon>
                        </md-button>
                        <p class="modal-title">BÚSCA TU RECURSO</p>
                        <md-button style="opacity:0" disabled class="md-icon-button">
                            <md-icon>arrow_back</md-icon>
                        </md-button>
                    </div>
                </div>
            </md-toolbar>

            <md-dialog-content>
                <form>
                    <div class=" md-layout md-alignment-top-right">
                        <div class="md-layout-item  md-size-100">
                            <md-field class="" md-inline>
                                <label>Busqueda por palabra clave</label>
                                <md-input v-model="searchWord"></md-input>
                            </md-field>
                        </div>
                        <div class="md-layout-item md-size-50">
                            <md-field class="" md-inline>
                                <label for="category">Categoría</label>
                                <md-select name="category" class="input-custom" id="category" v-model="searchCategory">
                                    <md-option v-for="item in categories" v-bind:key="item.id" :value="item.id"> {{ item.label }}</md-option>
                                </md-select>
                            </md-field>
                        </div>
                        <div class="md-layout-item md-size-50">
                            <md-autocomplete v-model="searchAuthor" :md-options="authors" class="autocomplete-autor">
                                <label>Autor</label>
                            </md-autocomplete>
                        </div>
                        <div class="md-layout-item md-size-100">
                            <md-button class="md-primary md-block md-raised btn-search" @click="Filter()">
                                BUSCAR
                            </md-button>
                        </div>
                    </div>
                </form>
            </md-dialog-content>
        </md-dialog>
    </div>
</template>

<script>
import axios from 'axios';
import { Modal } from '../../components';
import { validationMixin } from 'vuelidate';
import { required, email, minLength } from 'vuelidate/lib/validators';

export default {
    name: 'search-section',
    bodyClass: 'search-modal',
    props: {
        showModal: {
            type: Boolean,
            default: false
        }
    },
    components: {
        Modal
    },
    data() {
        return {
            loading: false,
            searchWord: '',
            searchAuthor: '',
            searchCategory: 0,
            categoriesEndPoint: '/api/categories',
            authorsSlugEndPoint: '/api/searchAuthor?slug=',
            categories: [],
            authors: [],
            authorsAll: []
        };
    },
    computed: {
        classicModal() {
            return this.showModal;
        }
    },
    methods: {
        searchModalHide() {
            // this.resetPassword = false;
            // this.$v.form.$reset();
            // this.$v.forgotPasswordForm.$reset();
            this.$emit('searchModalHide', event);
        },
        getCategories() {
            axios
                .get(this.categoriesEndPoint)
                .then((res) => {
                    if (res && res.data && res.data.categories) {
                        this.categories = res.data.categories;
                    } else {
                        this.categories = [];
                    }
                })
                .catch((error) => {
                    console.log('Error GetCategories' + error);
                });
        },
        getAuthorsSlug() {
            axios
                .get(this.authorsSlugEndPoint + this.searchAuthor)
                .then((res) => {
                    if (res && res.data && res.data.data) {
                        this.authorsAll = res.data.data;
                        this.authors = res.data.data.map((autor) => autor.username);
                    } else {
                        this.authors = [];
                    }
                })
                .catch((error) => {
                    console.log('Error getAuthorsSlug' + error);
                });
        },
        Filter() {
            const author_id = this.authorsAll.find((element) => element.username == this.searchAuthor);
            this.$router.replace({
                name: 'resources',
                query: {
                    title: this.searchWord,
                    category_id: this.searchCategory,
                    author_id: author_id ? author_id.id : null
                }
            });
            this.searchModalHide();
        }
    },
    mounted() {
        document.addEventListener('scroll', this.scrollListener);
        this.getCategories();
        // this.validateQueryParams();
    },
    beforeDestroy() {
        document.removeEventListener('scroll', this.scrollListener);
    }
};
</script>

<style lang="scss" scoped>
.md-dialog .md-dialog-container {
    max-width: 768px;
}

.search-button {
    width: 100%;
    color: white;
}
.modal-title {
    margin: auto;
}
.autocomplete-autor {
    margin-left: 3px;
}
.autocomplete-autor .md-field.md-clearable .md-input {
    border-left: 1px solid lightgrey;
}
.btn-search {
    margin: 0px;
}
// @media screen and (min-width: 767px) {
//     #modal-login {
//         width: 600px;
//     }

//     .md-dialog {
//         top: 35% !important;
//     }
// }

// .modal-title {
//     margin: 5px 0px;
//     font-size: x-large;
// }
</style>
